#include <iostream.h>
#include <string.h> 
#include <stdio.h> 
#include <stdlib.h> 
struct node

    {
    int id; 
    int phone; 
    char name[100]; 
    node *left; 
    node *right; 
}; 


class btree

    { 
    public: 
     node *root;
    btree(); /tree constructor
    void menu();
    void insert(int id, int phone, char first[100], char last[100], node *root);
    void insert(int id, int phone, char first[100], char last[100]);
    node *find(int id, node *root);
    node *find(int id);
    void del(node *ptr, int id);
    node *update(node *root, int id);
    void inorder(node *ptr);
    void postorder(node *ptr);
    void preorder(node *ptr);
}; 

btree::btree()

    { 
    root=NULL; 
}
void btree::menu() 

    { 
     int sel; 
     btree selection; 
     cout<<"********************* Binary Tree *********************"<<endl; 
     cout<<"====================== Main Menu ======================"<<endl; 
     cout<<"1. Insert"<<endl; 
     cout<<"2. Delete"<<endl; 
     cout<<"3. Find"<<endl; 
     cout<<"4. Update"<<endl; 
     cout<<"5. Print Inorder"<<endl; 
     cout<<"6. Print Preorder"<<endl; 
     cout<<"7. Print Postorder"<<endl; 
     cout<<"0. Exit"<<endl; 
     cout<<"Please make your selection between (0-7):"; 
     cin>>sel; 
     
     int id; 
     int phone; 
     char first[100]; 
     char last[100]; 
     if (sel == 1) 

         { 
         cout<<"\nEnter a new Student's ID: "; 
         cin>>id; 
         cout<<"Enter Student's First Name: "; 
         cin>>first; 
         cout<<"Enter Student's Last Name: "; 
         cin>>last; 
         cout<<"Enter Student's phone Number: "; 
         cin>>phone; 
         insert(id, phone, first, last); 
         cout<<"\n"<<endl; 
         menu(); 
         } 
         else if(sel == 2) 

             { 
             cout<<"\nEnter Student's ID: "; 
             cin>>id; 
             del(root, id); 
             cout<<"\n"<<endl; 
             menu(); 
             } 
             else if(sel == 3) 

                 { 
                 cout<<"\nEnter Student's ID: "; 
                 cin>>id; 
                 find(id); 
                 cout<<"\n"<<endl; 
                 menu(); 
                 } 
                 else if(sel == 4) 

                     { 
                     cout<<"\nEnter Student's ID: "; 
                     cin>>id; 
                     update(root, id); 
                     cout<<"\n"<<endl; 
                     menu(); 
                     } 
                     else if(sel == 5) 

                         { 
                         cout<<"\n\n Inorder: "<<endl; 
                         inorder(root); 
                         cout<<"\n"<<endl; 
                         menu(); 
                         } 
                         else if(sel == 6) 

                             { 
                             cout<<"\n\n Preorder: "<<endl; 
                             preorder(root); 
                             cout<<"\n"<<endl; 
                             menu(); 
                             } 
                             else if(sel == 7) 

                                 { 
                                 cout<<"\n\n Postorder: "<<endl; 
                                 postorder(root); 
                                 cout<<"\n"<<endl; 
                                 menu(); 
                                 } 
                                 else if(sel == 0) 

                                     { 
                                     cout<<"Thank You for using my Program! BYE!!!!!!!"<<endl; 
                                     } 
                                     else 

                                         { 
                                         cout<<"\n Enter numbers between 1-7 "<<endl; 
                                         cout<<"\n"; 
                                         menu(); 
                                         } 
                                    }
                                    void btree::insert(int id, int phone, char first[100], char last[100]) 

                                        { 
                                        if(root!=NULL)
                                        insert(id, phone, first, last, root); 
                                        else 

                                            {
                                            root=new node; 
                                            root->id=id; 
                                             root->phone=phone; 
                                             strcpy(root->name,first); 
                                             strcat(root->name,last); 
                                            root->left=NULL; 
                                            root->right=NULL; 
                                        } 

                                    }
                                    void btree::insert(int id, int phone, char first[100], char last[100], node *root) 

                                        { 
                                        if(id< root->id)

                                            { 
                                            if(root->left!=NULL)
                                            insert(id, phone, first, last, root->left); 
                                            else 

                                                { 
                                                root->left=new node; 
                                                root->left->id=id; 
                                                 root->left->phone=phone; 
                                                 strcpy(root->left->name,first); 
                                                 strcat(root->left->name,last);
                                                root->left->left=NULL;
                                                root->left->right=NULL;
                                            } 

                                        } 

                                        else if(id>=root->id)

                                            { 
                                            if(root->right!=NULL) 
                                            insert(id, phone, first, last, root->right); 
                                            else 

                                                { 
                                                root->right=new node; 
                                                root->right->id=id; 
                                                 root->right->phone=phone; 
                                                 strcpy(root->right->name,first); 
                                                 strcat(root->right->name,last); 
                                                root->right->left=NULL;
                                                root->right->right=NULL;
                                            } 

                                        } 

                                    }
                                    node *btree::find(int id, node *root) 

                                        { 
                                        if(root!=NULL) 

                                            { 
                                            if(id==root->id)

                                                 { 
                                                cout<<root->id<<" "<<root->phone<<" "<<root->name<<endl; 
                                                 return NULL; 
                                                 } 
                                                if(id<root->id)
                                                return find(id, root->left); 
                                                else
                                                return find(id, root->right); 
                                            } 

                                            else 

                                                { 
                                                cout<<"The ID Does not Exists in TREE"<<endl; 
                                                 return NULL; 
                                            } 


                                        }
                                        node *btree::find(int id) 

                                            { 
                                            return find(id, root); 
                                        }
                                        void btree::del(node *ptr, int id) 

                                            { 
                                             node *ptr1 = NULL; 
                                             node *ptr2 = NULL; 
                                             if(ptr!=NULL) 

                                                { 
                                                if(id==ptr->id) 

                                                     { 
                                                    if(ptr->left==NULL && ptr->right==NULL) 

                                                         { 
                                                         ptr = NULL; 
                                                         cout<<"ID DELETED SUCCESSFULLY!!!"<<endl; 
                                                         } 
                                                         else 
                                                         cout<<"THE ROOT HAS NO CHILDREN"<<endl; 
                                                         } 
                                                        else if(id<ptr->id) 
                                                        del(ptr->left, id); 
                                                        else if(id>ptr->id) 
                                                        del(ptr->right, id); 
                                                    } 

                                                    else 

                                                        { 
                                                        cout<<"The ID Does not Exists in TREE"<<endl; 
                                                    } 

                                                }
                                                node *btree::update(node *root, int id) 

                                                    { 
                                                     char first[100]; 
                                                     char last[100]; 
                                                     int phone; 
                                                     if(root!=NULL) 

                                                        { 
                                                        if(id==root->id)

                                                             { 
                                                            cout<<root->id<<" "<<root->phone<<" "<<root->name<<endl; 
                                                             cout << "Enter First Name: "; 
                                                             cin>>first; 
                                                             cout << "Enter Last Name: "; 
                                                             cin>>last; 
                                                             cout<<"Enter new phone number: "; 
                                                             cin>>phone; 
                                                             strcpy(root->name,first);
                                                             strcat(root->name,last); 
                                                             root->phone=phone; 
                                                             cout<<"ID Updated SuccessFully!!!!"<<endl; 
                                                             
                                                             return NULL; 
                                                             } 
                                                            if(id<root->id)
                                                            return update(root->left, id);
                                                            else
                                                            return update(root->right, id); 
                                                        } 

                                                        else 

                                                            { 
                                                            cout<<"The ID Does not Exists in TREE"<<endl; 
                                                             return NULL; 
                                                        } 

                                                         
                                                    } 

                                                    void btree::inorder(node *ptr) 

                                                        { 
                                                         if (ptr->left != NULL) 
                                                         inorder (ptr->left); 
                                                         cout<< ptr->id << " " <<ptr->phone<<" "<<ptr->name<<" "<<endl; 
                                                         if (ptr->right != NULL) 
                                                         inorder (ptr->right); 
                                                    } 

                                                    void btree::postorder(node *ptr) 

                                                        { 
                                                         if (ptr->left != NULL) 
                                                         postorder (ptr->left); 
                                                        if (ptr->right != NULL) 
                                                         postorder (ptr->right); 
                                                        cout<< ptr->id << " " <<ptr->phone<<" "<<ptr->name<<" "<<endl; 
                                                         
                                                    } 

                                                    void btree::preorder(node *ptr) 

                                                        { 
                                                         
                                                         cout<< ptr->id << " " <<ptr->phone<<" "<<ptr->name<<" "<<endl; 
                                                         
                                                        if (ptr->left != NULL) 
                                                         preorder (ptr->left); 
                                                        if (ptr->right != NULL) 
                                                         preorder (ptr->right); 
                                                    } 

                                                    void header(int n);
                                                    int main () 

                                                        { 
                                                         header(2); 
                                                         btree insert;
                                                         insert.insert(5254, 5552121, "Stacy", "Sinclair"); 
                                                         insert.insert(8754, 5557854, "Walter","Sobchak"); 
                                                         insert.insert(4848, 5556547, "Max", "Fisher"); 
                                                         insert.insert(8854, 5552424, "Flash", "Thompson"); 
                                                         insert.insert(5142, 5550022, "Maude", "Lebowski"); 
                                                         insert.insert(1110, 5558301, "Larry", "Sellers"); 
                                                         insert.insert(6254, 5551236, "Bob", "Zimmerman"); 
                                                         insert.menu(); 
                                                         return 0; 
                                                    }
                                                    void header(int n) 

                                                        { 
                                                         cout<<"******************************************************"<<endl;
                                                         cout<<"******************************************************"<<endl; 
                                                         cout<<endl;
                                                    }


